HeapPreview = {};
HeapPreview.modDir = g_currentModDirectory;
HeapPreview.settingsDir = getUserProfileAppPath().. "modSettings/FS25_HeapPreview/";
--fix player 10.01.2021 (join a player LS19) by HappyLooser
HeapPreview.metadata = {
	interface = "FS25 ...",
	title = "HeapPreview",
	notes = "Zeigt Aktuelle Fruchtart/Volumen von Haufen an",
	author = "(by HappyLooser)",
	version = "v0.85 Beta",	
	datum = "24.11.2016",
	update = "15.11.2024",
	web = " http://modhoster.de",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe: http://modhoster.de"
};

function HeapPreview:loadMap(name)		
	print("---loading ".. tostring(HeapPreview.metadata.title).. " ".. tostring(HeapPreview.metadata.version).. " ".. tostring(HeapPreview.metadata.author).. "---")
	if not HeapPreview:getServer() then	
		HeapPreview.hlDebugMode = false;
		loadScripts(1);
		hpSetGet:generateDisplay();		
		HeapPreview:loadSettings();		
		Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, HeapPreview.onStartMission);
	end;
end;

function HeapPreview:onStartMission()	
	if not HeapPreview:getServer() then 
		g_currentMission.hlUtils.modLoad("FS25_HeapPreview");
		HeapPreview:searchOtherMods();
		HeapPreview.values.foundHlHudSystem = g_currentMission.hlHudSystem ~= nil and g_currentMission.hlHudSystem.hlHud ~= nil and g_currentMission.hlHudSystem.hlHud.generate ~= nil; --check is HL Hud System ready !
		PlayerInputComponent.registerActionEvents = Utils.appendedFunction(PlayerInputComponent.registerActionEvents, HeapPreview.registerActionEventsPlayer); --damm Giants :-(
		HeapPreview:registerActionEventsPlayer();
		if HeapPreview.values.foundHlHudSystem then loadScripts(2);hpGuiBoxSetGet:insertGuiBoxLines();end;
	end;
end;

function HeapPreview:registerActionEventsPlayer()	
	local isOkay, eventName = InputBinding.registerActionEvent(g_inputBinding, 'HEAPPREVIEWONOFF', self, HeapPreview.actionKeyMouse, false, true, false, true);    
	if isOkay then 
		HeapPreview.values.binding.inputString = {};
		local action = g_inputBinding.nameActions["HEAPPREVIEWONOFF"];
		if action ~= nil and action.bindings ~= nil and  action.bindings[1] ~= nil and action.bindings[1].id ~= nil then
			HeapPreview.values.binding.isKeyboard = action.bindings[1].isKeyboard;
			HeapPreview.values.binding.isMouse = action.bindings[1].isMouse;
			HeapPreview.values.binding.isCombi = HeapPreview.values.binding.isMouse and HeapPreview.values.binding.isKeyboard;
			local split = g_currentMission.hlUtils.stringSplit(action.bindings[1].id, "|", "");
			if split[2] ~= nil then
				split = g_currentMission.hlUtils.stringSplit(split[2], ";", "");
				if split ~= nil and #split > 0 then
					for i=1, #split do
						if split[i] ~= nil and split[i]:len() > 1 then table.insert(HeapPreview.values.binding.inputString, split[i]);end;
					end;
				end;
			end;			
		end;
	end;
	--if isOkay then g_inputBinding.events[eventName].displayIsVisible = false;end;	
end;

function HeapPreview:actionKeyMouse(actionName, keyStatus, arg4, arg5, arg6) --damm Giants :-(
	--if not g_currentMission.hlUtils.dragDrop.on then
	--	if actionName == "HEAPPREVIEWONOFF" then			
	--		HeapPreview.values.isOn = not HeapPreview.values.isOn;	
	--	end;
	--end;
end;

function HeapPreview:deleteMap()
	if HeapPreview:getServer() then return;end;
	HeapPreview:saveSettings();
end;

function HeapPreview:mouseEvent(posX, posY, isDown, isUp, button)
	if HeapPreview:getServer() or g_currentMission.hlUtils:getIngameMap() or g_currentMission.hlUtils:getFullSize(true,true) then return;end;
	if #HeapPreview.values.binding.inputString > 0 and HeapPreview.values.binding.isMouse and not HeapPreview.values.binding.isCombi then hpMouseKeyEvents:temporarySetKeyMouseAction(isDown, false, true);end;
end;

function HeapPreview:keyEvent(unicode, sym, modifier, isDown)
	if HeapPreview:getServer() or g_currentMission.hlUtils:getIngameMap() or g_currentMission.hlUtils:getFullSize(true,true) then return;end;
	if #HeapPreview.values.binding.inputString > 0 and HeapPreview.values.binding.isKeyboard and not HeapPreview.values.binding.isCombi then hpMouseKeyEvents:temporarySetKeyMouseAction(isDown, true, false);end;	
end;

function HeapPreview:update(dt)	
	if HeapPreview:getServer() or g_currentMission.hlUtils:getIngameMap() or g_currentMission.hlUtils:getFullSize(true,true) then return;end;
	if not HeapPreview.values.isOn then return;end;
	if not HeapPreview:getPlayerData() then 
		hpSetGet:searchHeaps();
		if HeapPreview.values.foundHeap then
			hpSetGet:showInfoBoxOrText(true);
		else
			hpSetGet:showInfoBoxOrText(false);		
		end;
	end;
end;

function HeapPreview:draw(dt)
	if HeapPreview:getServer() or g_currentMission.hlUtils:getIngameMap() or g_currentMission.hlUtils:getFullSize(true,true) then return;end;
	if HeapPreview.values.isOn and HeapPreview.values.viewDebugCircle then setDebugCircle();end;
end;	
addModEventListener(HeapPreview);

function HeapPreview:searchOtherMods()	
	local env = getfenv(0);		
	
end;

function loadScripts(int)
	if int == 1 then		
		source(HeapPreview.modDir.."defaultSettings/hpLoadTables.lua");
		source(HeapPreview.modDir.."defaultSettings/hpSetGetSettingsXml.lua");
		source(HeapPreview.modDir.."scripte/hpSetGet.lua");
		source(HeapPreview.modDir.."scripte/mouseKeyEvents/hpMouseKeyEvents.lua");
	end;
	if int == 2 then
		source(HeapPreview.modDir.."scripte/hpGuiBoxSetGet.lua");
	end;
end;

function setDebugCircle()
	if g_currentMission.playerSystem ~= nil and g_currentMission.playerSystem.players ~= nil and g_currentMission.playerUserId ~= nil and g_currentMission.playerSystem.players[g_currentMission.playerUserId] ~= nil then
		if g_currentMission.playerSystem.players[g_currentMission.playerUserId].rootNode == nil then return;end; --MP Join Event
		if g_currentMission.playerSystem.players[g_currentMission.playerUserId]:getIsInVehicle() then return;end;
	end;
	return;
end;

function HeapPreview:getPlayerData(node)
	if g_currentMission.playerSystem ~= nil and g_currentMission.playerSystem.players ~= nil and g_currentMission.playerUserId ~= nil and g_currentMission.playerSystem.players[g_currentMission.playerUserId] ~= nil then
		if node then return g_currentMission.playerSystem.players[g_currentMission.playerUserId].rootNode;else return g_currentMission.playerSystem.players[g_currentMission.playerUserId]:getIsInVehicle();end;
	end;
	return nil;
end;

function HeapPreview:getServer()
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;	
end;

function HeapPreview:saveSettings()
	hpSetGetSettingsXml:saveConfig();	
end;

function HeapPreview:loadSettings()
	hpSetGetSettingsXml:loadConfig();	
end;